function ReloadChat_EventHandler(self, event, ...)
 if event=="PLAYER_LOGIN" then
  ReloadChat_Login(self, event);
 else
  ReloadChat_OnEvent(self, event, ...);
 end;
end;

--Login
function ReloadChat_Login(self, event)
 local maxLines=DEFAULT_CHAT_FRAME:GetMaxLines()
 if ReloadChat["Message1"]==nil then
  for i=1, maxLines do
   ReloadChat["Message"..i]={}
   ReloadChat["Message"..i]["text"]=""
   ReloadChat["Message"..i]["type"]=""
  end
 else
  for i=1, maxLines do
   local message=ReloadChat["Message"..(maxLines+1-i)]["text"]
   if message~="" then
    local type=ReloadChat["Message"..(maxLines+1-i)]["type"]
    local info=ChatTypeInfo[type]
    DEFAULT_CHAT_FRAME:AddMessage(message,info.r,info.g,info.b)
   end
  end
 end
end

if ReloadChat==nil then
 ReloadChat={}
end


--Addon code


function ReloadChat_OnEvent(self, event, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10, arg11, arg12)
 local maxLines = DEFAULT_CHAT_FRAME:GetMaxLines()
 for i=1, (maxLines-1) do
  ReloadChat["Message"..(maxLines+1-i)]["text"]=ReloadChat["Message"..(maxLines-i)]["text"]
  ReloadChat["Message"..(maxLines+1-i)]["type"]=ReloadChat["Message"..(maxLines-i)]["type"]
 end
 if event=="CHAT_MSG_SAY" then
  ReloadChat["Message1"]["text"]=("\124Hplayer:"..arg2..":"..arg8.."\124h["..arg2.."]\124h says: "..arg1)
  ReloadChat["Message1"]["type"]="SAY"
 end
 if event=="CHAT_MSG_EMOTE" then
  ReloadChat["Message1"]["text"]=(arg2.." "..arg1)
  ReloadChat["Message1"]["type"]="EMOTE"
 end
 if event=="CHAT_MSG_YELL" then
  ReloadChat["Message1"]["text"]=("\124Hplayer:"..arg2..":"..arg8.."\124h["..arg2.."]\124h yells: "..arg1)
  ReloadChat["Message1"]["type"]="YELL"
 end
 if event=="CHAT_MSG_GUILD" then
  ReloadChat["Message1"]["text"]=("[Guild] \124Hplayer:"..arg2..":"..arg8.."\124h["..arg2.."]\124h: "..arg1)
  ReloadChat["Message1"]["type"]="GUILD"
 end
 if event=="CHAT_MSG_OFFICER" then
  ReloadChat["Message1"]["text"]=("[Officer] \124Hplayer:"..arg2..":"..arg8.."\124h["..arg2.."]\124h: "..arg1)
  ReloadChat["Message1"]["type"]="OFFICER"
 end
 if event=="CHAT_MSG_GUILD_ACHIEVEMENT" then
  ReloadChat["Message1"]["text"]=("\124Hplayer:"..arg2..":"..arg8.."\124h["..arg2.."]\124h: "..arg1)
  ReloadChat["Message1"]["type"]="GUILD_ACHIEVEMENT"
 end
 if event=="CHAT_MSG_ACHIEVEMENT" then
  ReloadChat["Message1"]["text"]=("\124Hplayer:"..arg2..":"..arg8.."\124h["..arg2.."]\124h: "..arg1)
  ReloadChat["Message1"]["type"]="ACHIEVEMENT"
 end
 if event=="CHAT_MSG_WHISPER" then
  ReloadChat["Message1"]["text"]=("\124Hplayer:"..arg2..":"..arg8.."\124h["..arg2.."]\124h whispers: "..arg1)
  ReloadChat["Message1"]["type"]="WHISPER"
 end
 if event=="CHAT_MSG_WHISPER_INFORM" then
  ReloadChat["Message1"]["text"]=("To \124Hplayer:"..arg2..":"..arg8.."\124h["..arg2.."]\124h: "..arg1)
  ReloadChat["Message1"]["type"]="WHISPER_INFORM"
 end
 if event=="CHAT_MSG_BN_WHISPER" then
  ReloadChat["Message1"]["text"]=("\124Hplayer:"..arg2..":"..arg8.."\124h["..arg2.."]\124h whispers: "..arg1)
  ReloadChat["Message1"]["type"]="BN_WHISPER"
 end
 if event=="CHAT_MSG_BN_WHISPER_INFORM" then
  ReloadChat["Message1"]["text"]=("To \124Hplayer:"..arg2..":"..arg8.."\124h["..arg2.."]\124h: "..arg1)
  ReloadChat["Message1"]["type"]="BN_WHISPER_INFORM"
 end
 if event=="CHAT_MSG_PARTY" then
  ReloadChat["Message1"]["text"]=("[Party] \124Hplayer:"..arg2..":"..arg8.."\124h["..arg2.."]\124h: "..arg1)
  ReloadChat["Message1"]["type"]="PARTY"
 end
 if event=="CHAT_MSG_PARTY_LEADER" then
  ReloadChat["Message1"]["text"]=("[Party Leader] \124Hplayer:"..arg2..":"..arg8.."\124h["..arg2.."]\124h: "..arg1)
  ReloadChat["Message1"]["type"]="PARTY_LEADER"
 end
 if event=="CHAT_MSG_RAID" then
  ReloadChat["Message1"]["text"]=("[Raid] \124Hplayer:"..arg2..":"..arg8.."\124h["..arg2.."]\124h: "..arg1)
  ReloadChat["Message1"]["type"]="RAID"
 end
 if event=="CHAT_MSG_RAID_LEADER" then
  ReloadChat["Message1"]["text"]=("[Raid Leader] \124Hplayer:"..arg2..":"..arg8.."\124h["..arg2.."]\124h: "..arg1)
  ReloadChat["Message1"]["type"]="RAID_LEADER"
 end
 if event=="CHAT_MSG_RAID_WARNING" then
  ReloadChat["Message1"]["text"]=("[Raid Warning] \124Hplayer:"..arg2..":"..arg8.."\124h["..arg2.."]\124h: "..arg1)
  ReloadChat["Message1"]["type"]="RAID_WARNING"
 end
 if event=="CHAT_MSG_BATTLEGROUND" then
  ReloadChat["Message1"]["text"]=("[Battleground] \124Hplayer:"..arg2..":"..arg8.."\124h["..arg2.."]\124h: "..arg1)
  ReloadChat["Message1"]["type"]="BATTLEGROUND"
 end
 if event=="CHAT_MSG_BATTLEGROUND_LEADER" then
  ReloadChat["Message1"]["text"]=("[Battleground Leader] \124Hplayer:"..arg2..":"..arg8.."\124h["..arg2.."]\124h: "..arg1)
  ReloadChat["Message1"]["type"]="BATTLEGROUND_LEADER"
 end
end

ReloadChat=CreateFrame("Frame")
ReloadChat:RegisterEvent("PLAYER_LOGIN")
ReloadChat:RegisterEvent("CHAT_MSG_SAY")
ReloadChat:RegisterEvent("CHAT_MSG_EMOTE")
ReloadChat:RegisterEvent("CHAT_MSG_YELL")
ReloadChat:RegisterEvent("CHAT_MSG_GUILD")
ReloadChat:RegisterEvent("CHAT_MSG_OFFICER")
ReloadChat:RegisterEvent("CHAT_MSG_GUILD_ACHIEVEMENT")
ReloadChat:RegisterEvent("CHAT_MSG_ACHIEVEMENT")
ReloadChat:RegisterEvent("CHAT_MSG_WHISPER")
ReloadChat:RegisterEvent("CHAT_MSG_WHISPER_INFORM")
ReloadChat:RegisterEvent("CHAT_MSG_BN_WHISPER")
ReloadChat:RegisterEvent("CHAT_MSG_BN_WHISPER_INFORM")
ReloadChat:RegisterEvent("CHAT_MSG_PARTY")
ReloadChat:RegisterEvent("CHAT_MSG_PARTY_LEADER")
ReloadChat:RegisterEvent("CHAT_MSG_RAID")
ReloadChat:RegisterEvent("CHAT_MSG_RAID_LEADER")
ReloadChat:RegisterEvent("CHAT_MSG_RAID_WARNING")
ReloadChat:RegisterEvent("CHAT_MSG_BATTLEGROUND")
ReloadChat:RegisterEvent("CHAT_MSG_BATTLEGROUND_LEADER")
--ReloadChat:RegisterEvent("CHAT_MSG_BN_CONVERSATION")
ReloadChat:SetScript("OnEvent",ReloadChat_EventHandler)

